Index: trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp	(revision 108128)
+++ trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp	(revision 108137)
@@ -1648,4 +1648,5 @@
     {
         case UIToolType_Home:         strResult = "Home"; break;
+        case UIToolType_Machines:     strResult = "Machines"; break;
         case UIToolType_Extensions:   strResult = "Extensions"; break;
         case UIToolType_Media:        strResult = "Media"; break;
@@ -1654,5 +1655,4 @@
         case UIToolType_CloudConsole: strResult = "CloudConsole"; break;
         case UIToolType_Activities:   strResult = "Activities"; break;
-        case UIToolType_Machines:     strResult = "Machines"; break;
         case UIToolType_Details:      strResult = "Details"; break;
         case UIToolType_Snapshots:    strResult = "Snapshots"; break;
@@ -1674,4 +1674,6 @@
     if (strToolType.compare("Home", Qt::CaseInsensitive) == 0)
         return UIToolType_Home;
+    if (strToolType.compare("Machines", Qt::CaseInsensitive) == 0)
+        return UIToolType_Machines;
     if (strToolType.compare("Extensions", Qt::CaseInsensitive) == 0)
         return UIToolType_Extensions;
@@ -1686,6 +1688,4 @@
     if (strToolType.compare("Activities", Qt::CaseInsensitive) == 0)
         return UIToolType_Activities;
-    if (strToolType.compare("Machines", Qt::CaseInsensitive) == 0)
-        return UIToolType_Machines;
     if (strToolType.compare("Details", Qt::CaseInsensitive) == 0)
         return UIToolType_Details;
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 108128)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 108137)
@@ -302,4 +302,5 @@
             {
                 case UIToolType_Home:
+                case UIToolType_Machines:
                 case UIToolType_Extensions:
                 case UIToolType_Media:
@@ -308,5 +309,4 @@
                 case UIToolType_CloudConsole:
                 case UIToolType_Activities:
-                case UIToolType_Machines:
                     return true;
                 default:
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 108128)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 108137)
@@ -953,4 +953,5 @@
     /* Global types: */
     UIToolType_Home,
+    UIToolType_Machines,
     UIToolType_Extensions,
     UIToolType_Media,
@@ -959,5 +960,4 @@
     UIToolType_CloudConsole,
     UIToolType_Activities,
-    UIToolType_Machines,
     /* Machine types: */
     UIToolType_Error,
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolManager.cpp	(revision 108128)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolManager.cpp	(revision 108137)
@@ -205,4 +205,36 @@
 };
 
+/** Simple action extension, used as 'Machine Manager' action class. */
+class UIActionToggleManagerToolsGlobalShowMachineManager : public UIActionToggle
+{
+    Q_OBJECT;
+
+public:
+
+    /** Constructs action passing @a pParent to the base-class. */
+    UIActionToggleManagerToolsGlobalShowMachineManager(UIActionPool *pParent)
+        : UIActionToggle(pParent)
+    {
+        setProperty("UIToolType", QVariant::fromValue(UIToolType_Machines));
+        /// @todo use icons with check-boxes
+        setIcon(UIIconPool::iconSetFull(":/machine_24px.png", ":/machine_16px.png"));
+    }
+
+protected:
+
+    /** Returns shortcut extra-data ID. */
+    virtual QString shortcutExtraDataID() const RT_OVERRIDE
+    {
+        return QString("ToolsGlobalMachineManager");
+    }
+
+    /** Handles translation event. */
+    virtual void retranslateUi() RT_OVERRIDE
+    {
+        setName(QApplication::translate("UIActionPool", "&Machine Manager"));
+        setStatusTip(QApplication::translate("UIActionPool", "Open the Machine Manager"));
+    }
+};
+
 /** Simple action extension, used as 'Show Extension Pack Manager' action class. */
 class UIActionToggleManagerToolsGlobalShowExtensionPackManager : public UIActionToggle
@@ -391,36 +423,4 @@
         setName(QApplication::translate("UIActionPool", "&VM Activity Overview"));
         setStatusTip(QApplication::translate("UIActionPool", "Open the VM Activity Overview"));
-    }
-};
-
-/** Simple action extension, used as 'Machine Manager' action class. */
-class UIActionToggleManagerToolsGlobalShowMachineManager : public UIActionToggle
-{
-    Q_OBJECT;
-
-public:
-
-    /** Constructs action passing @a pParent to the base-class. */
-    UIActionToggleManagerToolsGlobalShowMachineManager(UIActionPool *pParent)
-        : UIActionToggle(pParent)
-    {
-        setProperty("UIToolType", QVariant::fromValue(UIToolType_Machines));
-        /// @todo use icons with check-boxes
-        setIcon(UIIconPool::iconSetFull(":/machine_24px.png", ":/machine_16px.png"));
-    }
-
-protected:
-
-    /** Returns shortcut extra-data ID. */
-    virtual QString shortcutExtraDataID() const RT_OVERRIDE
-    {
-        return QString("ToolsGlobalMachineManager");
-    }
-
-    /** Handles translation event. */
-    virtual void retranslateUi() RT_OVERRIDE
-    {
-        setName(QApplication::translate("UIActionPool", "&Machine Manager"));
-        setStatusTip(QApplication::translate("UIActionPool", "Open the Machine Manager"));
     }
 };
@@ -3528,4 +3528,5 @@
     m_pool[UIActionIndexMN_M_File_M_Tools] = new UIActionMenuManagerToolsGlobal(this);
     m_pool[UIActionIndexMN_M_File_M_Tools_T_HomeScreen] = new UIActionToggleManagerToolsGlobalShowHomeScreen(this);
+    m_pool[UIActionIndexMN_M_File_M_Tools_T_MachineManager] = new UIActionToggleManagerToolsGlobalShowMachineManager(this);
     m_pool[UIActionIndexMN_M_File_M_Tools_T_ExtensionPackManager] = new UIActionToggleManagerToolsGlobalShowExtensionPackManager(this);
     m_pool[UIActionIndexMN_M_File_M_Tools_T_VirtualMediaManager] = new UIActionToggleManagerToolsGlobalShowVirtualMediaManager(this);
@@ -3533,5 +3534,4 @@
     m_pool[UIActionIndexMN_M_File_M_Tools_T_CloudProfileManager] = new UIActionToggleManagerToolsGlobalShowCloudProfileManager(this);
     m_pool[UIActionIndexMN_M_File_M_Tools_T_VMActivityOverview] = new UIActionToggleManagerToolsGlobalShowVMActivityOverview(this);
-    m_pool[UIActionIndexMN_M_File_M_Tools_T_MachineManager] = new UIActionToggleManagerToolsGlobalShowMachineManager(this);
 #ifdef VBOX_GUI_WITH_EXTRADATA_MANAGER_UI
     m_pool[UIActionIndexMN_M_File_S_ShowExtraDataManager] = new UIActionSimpleManagerFileShowExtraDataManager(this);
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp	(revision 108128)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp	(revision 108137)
@@ -56,4 +56,7 @@
     , m_pLayout(0)
     , m_pPaneHome(0)
+#ifdef VBOX_GUI_WITH_ADVANCED_WIDGETS
+    , m_pPaneMachines(0)
+#endif
     , m_pPaneExtensions(0)
     , m_pPaneMedia(0)
@@ -61,7 +64,4 @@
     , m_pPaneCloud(0)
     , m_pPaneActivities(0)
-#ifdef VBOX_GUI_WITH_ADVANCED_WIDGETS
-    , m_pPaneMachines(0)
-#endif
     , m_fActive(false)
 {
@@ -136,4 +136,26 @@
                 break;
             }
+#ifdef VBOX_GUI_WITH_ADVANCED_WIDGETS
+            case UIToolType_Machines:
+            {
+                /* Create Machine Manager: */
+                m_pPaneMachines = new UIMachineManagerWidget(this, m_pActionPool);
+                AssertPtrReturnVoid(m_pPaneMachines);
+                {
+                    /* Configure pane: */
+                    m_pPaneMachines->setProperty("ToolType", QVariant::fromValue(UIToolType_Machines));
+                    /// @todo connect!
+# ifndef VBOX_WS_MAC
+                    const int iMargin = qApp->style()->pixelMetric(QStyle::PM_LayoutLeftMargin) / 4;
+                    m_pPaneMachines->setContentsMargins(iMargin, 0, iMargin, 0);
+# endif
+
+                    /* Add into layout: */
+                    m_pLayout->addWidget(m_pPaneMachines);
+                    m_pLayout->setCurrentWidget(m_pPaneMachines);
+                }
+                break;
+            }
+#endif /* VBOX_GUI_WITH_ADVANCED_WIDGETS */
             case UIToolType_Extensions:
             {
@@ -238,26 +260,4 @@
                 break;
             }
-#ifdef VBOX_GUI_WITH_ADVANCED_WIDGETS
-            case UIToolType_Machines:
-            {
-                /* Create Machine Manager: */
-                m_pPaneMachines = new UIMachineManagerWidget(this, m_pActionPool);
-                AssertPtrReturnVoid(m_pPaneMachines);
-                {
-                    /* Configure pane: */
-                    m_pPaneMachines->setProperty("ToolType", QVariant::fromValue(UIToolType_Machines));
-                    /// @todo connect!
-# ifndef VBOX_WS_MAC
-                    const int iMargin = qApp->style()->pixelMetric(QStyle::PM_LayoutLeftMargin) / 4;
-                    m_pPaneMachines->setContentsMargins(iMargin, 0, iMargin, 0);
-# endif
-
-                    /* Add into layout: */
-                    m_pLayout->addWidget(m_pPaneMachines);
-                    m_pLayout->setCurrentWidget(m_pPaneMachines);
-                }
-                break;
-            }
-#endif /* VBOX_GUI_WITH_ADVANCED_WIDGETS */
             default:
                 AssertFailedReturnVoid();
@@ -284,4 +284,7 @@
         {
             case UIToolType_Home:       m_pPaneHome = 0; break;
+#ifdef VBOX_GUI_WITH_ADVANCED_WIDGETS
+            case UIToolType_Machines:   m_pPaneMachines = 0; break;
+#endif
             case UIToolType_Extensions: m_pPaneExtensions = 0; break;
             case UIToolType_Media:      m_pPaneMedia = 0; break;
@@ -289,7 +292,4 @@
             case UIToolType_Cloud:      m_pPaneCloud = 0; break;
             case UIToolType_Activities: m_pPaneActivities = 0; break;
-#ifdef VBOX_GUI_WITH_ADVANCED_WIDGETS
-            case UIToolType_Machines:   m_pPaneMachines = 0; break;
-#endif
             default: break;
         }
@@ -312,4 +312,9 @@
             pCurrentToolWidget = m_pPaneHome;
             break;
+#ifdef VBOX_GUI_WITH_ADVANCED_WIDGETS
+        case UIToolType_Machines:
+            pCurrentToolWidget = m_pPaneMachines;
+            break;
+#endif
         case UIToolType_Extensions:
             pCurrentToolWidget = m_pPaneExtensions;
@@ -327,9 +332,4 @@
             pCurrentToolWidget = m_pPaneActivities;
             break;
-#ifdef VBOX_GUI_WITH_ADVANCED_WIDGETS
-        case UIToolType_Machines:
-            pCurrentToolWidget = m_pPaneMachines;
-            break;
-#endif
         default:
             break;
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.h	(revision 108128)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.h	(revision 108137)
@@ -123,4 +123,8 @@
     /** Holds the Home pane instance. */
     UIHomePane                   *m_pPaneHome;
+#ifdef VBOX_GUI_WITH_ADVANCED_WIDGETS
+    /** Holds the Machine Manager instance. */
+    UIMachineManagerWidget       *m_pPaneMachines;
+#endif
     /** Holds the Extension Pack Manager instance. */
     UIExtensionPackManagerWidget *m_pPaneExtensions;
@@ -133,8 +137,4 @@
     /** Holds the VM Activity Overview instance. */
     UIVMActivityOverviewWidget   *m_pPaneActivities;
-#ifdef VBOX_GUI_WITH_ADVANCED_WIDGETS
-    /** Holds the Machine Manager instance. */
-    UIMachineManagerWidget       *m_pPaneMachines;
-#endif
 
     /** Holds whether this pane is active. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerAdvancedWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerAdvancedWidget.cpp	(revision 108128)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerAdvancedWidget.cpp	(revision 108137)
@@ -501,60 +501,4 @@
             m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_File_S_ImportAppliance));
             m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_File_S_ExportAppliance));
-            break;
-        }
-        case UIToolType_Extensions:
-        {
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Extension_S_Install));
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Extension_S_Uninstall));
-            break;
-        }
-        case UIToolType_Media:
-        {
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_S_Add));
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_S_Create));
-            m_pToolBar->addSeparator();
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_S_Copy));
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_S_Move));
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_S_Remove));
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_S_Release));
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_S_Clear));
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_T_Search));
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_T_Details));
-            m_pToolBar->addSeparator();
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_S_Refresh));
-            break;
-        }
-        case UIToolType_Network:
-        {
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Network_S_Create));
-            m_pToolBar->addSeparator();
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Network_S_Remove));
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Network_T_Details));
-            //m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Network_S_Refresh));
-            break;
-        }
-        case UIToolType_Cloud:
-        {
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Cloud_S_Add));
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Cloud_S_Import));
-            m_pToolBar->addSeparator();
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Cloud_S_Remove));
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Cloud_T_Details));
-            m_pToolBar->addSeparator();
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Cloud_S_TryPage));
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Cloud_S_Help));
-            break;
-        }
-        case UIToolType_Activities:
-        {
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_VMActivityOverview_M_Columns));
-            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_VMActivityOverview_S_SwitchToMachineActivity));
-            QToolButton *pButton =
-                qobject_cast<QToolButton*>(m_pToolBar->widgetForAction(actionPool()->action(UIActionIndexMN_M_VMActivityOverview_M_Columns)));
-            if (pButton)
-            {
-                pButton->setPopupMode(QToolButton::InstantPopup);
-                pButton->setAutoRaise(true);
-            }
             break;
         }
@@ -655,4 +599,60 @@
             break;
         }
+        case UIToolType_Extensions:
+        {
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Extension_S_Install));
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Extension_S_Uninstall));
+            break;
+        }
+        case UIToolType_Media:
+        {
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_S_Add));
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_S_Create));
+            m_pToolBar->addSeparator();
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_S_Copy));
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_S_Move));
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_S_Remove));
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_S_Release));
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_S_Clear));
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_T_Search));
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_T_Details));
+            m_pToolBar->addSeparator();
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Medium_S_Refresh));
+            break;
+        }
+        case UIToolType_Network:
+        {
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Network_S_Create));
+            m_pToolBar->addSeparator();
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Network_S_Remove));
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Network_T_Details));
+            //m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Network_S_Refresh));
+            break;
+        }
+        case UIToolType_Cloud:
+        {
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Cloud_S_Add));
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Cloud_S_Import));
+            m_pToolBar->addSeparator();
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Cloud_S_Remove));
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Cloud_T_Details));
+            m_pToolBar->addSeparator();
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Cloud_S_TryPage));
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Cloud_S_Help));
+            break;
+        }
+        case UIToolType_Activities:
+        {
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_VMActivityOverview_M_Columns));
+            m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_VMActivityOverview_S_SwitchToMachineActivity));
+            QToolButton *pButton =
+                qobject_cast<QToolButton*>(m_pToolBar->widgetForAction(actionPool()->action(UIActionIndexMN_M_VMActivityOverview_M_Columns)));
+            if (pButton)
+            {
+                pButton->setPopupMode(QToolButton::InstantPopup);
+                pButton->setAutoRaise(true);
+            }
+            break;
+        }
         default:
             break;
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp	(revision 108128)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp	(revision 108137)
@@ -226,4 +226,7 @@
     QMap<UIToolType, UIAction*> actions;
     actions[UIToolType_Home] = actionPool()->action(UIActionIndexMN_M_File_M_Tools_T_HomeScreen);
+#ifdef VBOX_GUI_WITH_ADVANCED_WIDGETS
+    actions[UIToolType_Machines] = actionPool()->action(UIActionIndexMN_M_File_M_Tools_T_MachineManager);
+#endif
     actions[UIToolType_Extensions] = actionPool()->action(UIActionIndexMN_M_File_M_Tools_T_ExtensionPackManager);
     actions[UIToolType_Media] = actionPool()->action(UIActionIndexMN_M_File_M_Tools_T_VirtualMediaManager);
@@ -231,7 +234,4 @@
     actions[UIToolType_Cloud] = actionPool()->action(UIActionIndexMN_M_File_M_Tools_T_CloudProfileManager);
     actions[UIToolType_Activities] = actionPool()->action(UIActionIndexMN_M_File_M_Tools_T_VMActivityOverview);
-#ifdef VBOX_GUI_WITH_ADVANCED_WIDGETS
-    actions[UIToolType_Machines] = actionPool()->action(UIActionIndexMN_M_File_M_Tools_T_MachineManager);
-#endif
     if (actions.contains(enmType))
         actions.value(enmType)->setChecked(true);
@@ -506,6 +506,11 @@
         switch (pItem->itemType())
         {
+#ifdef VBOX_GUI_WITH_ADVANCED_WIDGETS
+            case UIToolType_Toggle:      pItem->setName(QString()); break;
+#endif
             case UIToolType_Home:        pItem->setName(tr("Home")); break;
-            case UIToolType_Toggle:      pItem->setName(QString()); break;
+#ifdef VBOX_GUI_WITH_ADVANCED_WIDGETS
+            case UIToolType_Machines:    pItem->setName(tr("Machines")); break;
+#endif
             case UIToolType_Extensions:  pItem->setName(tr("Extensions")); break;
             case UIToolType_Media:       pItem->setName(tr("Media")); break;
@@ -513,7 +518,4 @@
             case UIToolType_Cloud:       pItem->setName(tr("Cloud")); break;
             case UIToolType_Activities:  pItem->setName(tr("Activities")); break;
-#ifdef VBOX_GUI_WITH_ADVANCED_WIDGETS
-            case UIToolType_Machines:    pItem->setName(tr("Machines")); break;
-#endif
             case UIToolType_Details:     pItem->setName(tr("Details")); break;
             case UIToolType_Snapshots:   pItem->setName(tr("Snapshots")); break;