Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIBaseMemoryEditor.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIBaseMemoryEditor.cpp	(revision 108162)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIBaseMemoryEditor.cpp	(revision 108163)
@@ -304,5 +304,5 @@
         m_pLabelMemory->setText(tr("Base &Memory"));
 
-    const QString strToolTip(tr("The amount of RAM that VirtualBox will allocate to the virtual machine every time it is started."));
+    const QString strToolTip(tr("The amount of RAM that VirtualBox will allocate to the virtual machine every time it is started"));
     if (m_pSlider)
         m_pSlider->setToolTip(strToolTip);
@@ -316,10 +316,10 @@
     {
         m_pLabelMemoryMin->setText(tr("%1 MB").arg(m_pSlider->minRAM()));
-        m_pLabelMemoryMin->setToolTip(tr("Minimum possible base memory size."));
+        m_pLabelMemoryMin->setToolTip(tr("Minimum possible base memory size"));
     }
     if (m_pLabelMemoryMax)
     {
         m_pLabelMemoryMax->setText(tr("%1 MB").arg(m_pSlider->maxRAM()));
-        m_pLabelMemoryMax->setToolTip(tr("Maximum possible base memory size."));
+        m_pLabelMemoryMax->setToolTip(tr("Maximum possible base memory size"));
     }
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UINameAndSystemEditor.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UINameAndSystemEditor.cpp	(revision 108162)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UINameAndSystemEditor.cpp	(revision 108163)
@@ -300,14 +300,14 @@
 
     if (m_pEditorName)
-        m_pEditorName->setToolTip(tr("Descriptive name to uniquely identify the virtual machine."));
+        m_pEditorName->setToolTip(tr("Descriptive name to uniquely identify the virtual machine"));
     if (m_pSelectorPath)
-        m_pSelectorPath->setToolTip(tr("Storage location for virtual machine files."));
+        m_pSelectorPath->setToolTip(tr("Storage location for virtual machine files"));
     if (m_pComboEdition)
-        m_pComboEdition->setToolTip(tr("Edition of guest operating system to install."));
+        m_pComboEdition->setToolTip(tr("Edition of guest operating system to install"));
     if (m_pComboFamily)
-        m_pComboFamily->setToolTip(tr("Guest operating system type."));
+        m_pComboFamily->setToolTip(tr("Guest operating system type"));
 
     if (m_pComboDistribution)
-        m_pComboDistribution->setToolTip(tr("Guest operating system variant, if applicable."));
+        m_pComboDistribution->setToolTip(tr("Guest operating system variant, if applicable"));
     if (m_pComboType)
         m_pComboType->setToolTip(tr("Guest operating system version to install"));
@@ -315,5 +315,5 @@
     if (m_pSelectorImage)
         m_pSelectorImage->setToolTip(tr("ISO image to be attached to the "
-                                        "virtual machine and possibly used in unattended install."));
+                                        "virtual machine and possibly used in unattended install"));
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIHostnameDomainNameEditor.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIHostnameDomainNameEditor.cpp	(revision 108162)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIHostnameDomainNameEditor.cpp	(revision 108163)
@@ -118,20 +118,20 @@
 {
     if (m_pHostnameLabel)
-        m_pHostnameLabel->setText(tr("Host Na&me:"));
-    if (m_pHostnameLineEdit)
-        m_pHostnameLineEdit->setToolTip(tr("Host name to be assigned to the virtual machine."));
+        m_pHostnameLabel->setText(tr("Host Na&me"));
+    if (m_pHostnameLineEdit)
+        m_pHostnameLineEdit->setToolTip(tr("Host name to be assigned to the virtual machine"));
     if (m_pDomainNameLabel)
-        m_pDomainNameLabel->setText(tr("&Domain Name:"));
-    if (m_pDomainNameLineEdit)
-        m_pDomainNameLineEdit->setToolTip(tr("Doamin name to be assigned to the virtual machine."));
+        m_pDomainNameLabel->setText(tr("&Domain Name"));
+    if (m_pDomainNameLineEdit)
+        m_pDomainNameLineEdit->setToolTip(tr("Doamin name to be assigned to the virtual machine"));
     if (m_pProductKeyLabel)
-        m_pProductKeyLabel->setText(UIWizardNewVM::tr("&Product Key:"));
+        m_pProductKeyLabel->setText(UIWizardNewVM::tr("&Product Key"));
     if (m_pProductKeyLineEdit)
-        m_pProductKeyLineEdit->setToolTip(UIWizardNewVM::tr("The product key."));
+        m_pProductKeyLineEdit->setToolTip(UIWizardNewVM::tr("The product key"));
 
     if (m_pStartHeadlessCheckBox)
     {
         m_pStartHeadlessCheckBox->setText(UIWizardNewVM::tr("&Install in Background"));
-        m_pStartHeadlessCheckBox->setToolTip(UIWizardNewVM::tr("Start the virtusl machine without a GUI."));
+        m_pStartHeadlessCheckBox->setToolTip(UIWizardNewVM::tr("Start the virtual machine without a GUI"));
     }
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIUserNamePasswordEditor.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIUserNamePasswordEditor.cpp	(revision 108162)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIUserNamePasswordEditor.cpp	(revision 108163)
@@ -280,11 +280,11 @@
     QString strUsername = tr("U&ser Name");
     if (m_pUserNameLabel)
-        m_pUserNameLabel->setText(QString("%1%2").arg(strUsername).arg(":"));
+        m_pUserNameLabel->setText(strUsername);
 
     if (m_pPasswordLabel)
-        m_pPasswordLabel->setText(QString("%1%2").arg(strPassword).arg(":"));
+        m_pPasswordLabel->setText(strPassword);
 
     if (m_pPasswordRepeatLabel)
-        m_pPasswordRepeatLabel->setText(QString("%1%2").arg(strRepeatPassword).arg(":"));
+        m_pPasswordRepeatLabel->setText(strRepeatPassword);
 
     if (m_fShowPlaceholderText)
@@ -307,9 +307,9 @@
     }
     if(m_pUserNameLineEdit)
-        m_pUserNameLineEdit->setToolTip(tr("User name for the guest operating system."));
+        m_pUserNameLineEdit->setToolTip(tr("User name for the guest operating system"));
     if (m_pPasswordLineEdit)
-        m_pPasswordLineEdit->setToolTip(tr("Password for the guest operating system user account."));
+        m_pPasswordLineEdit->setToolTip(tr("Password for the guest operating system user account"));
     if (m_pPasswordRepeatLineEdit)
-        m_pPasswordRepeatLineEdit->setToolTip(tr("Password must match."));
+        m_pPasswordRepeatLineEdit->setToolTip(tr("Password must match"));
     m_strPasswordError = tr("Invalid password pair");
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardNewVMEditors.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardNewVMEditors.cpp	(revision 108162)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardNewVMEditors.cpp	(revision 108163)
@@ -175,9 +175,9 @@
 {
     if (m_pGAISOFilePathSelector)
-        m_pGAISOFilePathSelector->setToolTip(UIWizardNewVM::tr("Selects an installation medium (ISO file) for the Guest Additions."));
+        m_pGAISOFilePathSelector->setToolTip(UIWizardNewVM::tr("The ISO file to install the VirtualBox Guest Additions"));
     if (m_pGAISOPathLabel)
-        m_pGAISOPathLabel->setText(UIWizardNewVM::tr("Guest &Additions ISO:"));
+        m_pGAISOPathLabel->setText(UIWizardNewVM::tr("Guest &Additions ISO Image:"));
     setTitle(UIWizardNewVM::tr("Install Gu&est Additions"));
-    setToolTip(UIWizardNewVM::tr("When checked, the guest additions will be installed after the guest OS install."));
+    setToolTip(UIWizardNewVM::tr("When checked, the guest additions will be installed after the guest OS install"));
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMNameOSTypePage.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMNameOSTypePage.cpp	(revision 108162)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMNameOSTypePage.cpp	(revision 108163)
@@ -575,5 +575,5 @@
     {
         m_pUnattendedCheckBox->setText(UIWizardNewVM::tr("&Proceed with Unattended Installation"));
-        m_pUnattendedCheckBox->setToolTip(UIWizardNewVM::tr("When checked, the unattended install is enabled."));
+        m_pUnattendedCheckBox->setToolTip(UIWizardNewVM::tr("The ISO is attached to the VM, so you can install the OS manually"));
     }
 