Index: trunk/src/VBox/VMM/VMMAll/target-x86/IEMAllInstOneByte-x86.cpp.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/target-x86/IEMAllInstOneByte-x86.cpp.h	(revision 108267)
+++ trunk/src/VBox/VMM/VMMAll/target-x86/IEMAllInstOneByte-x86.cpp.h	(revision 108269)
@@ -15296,5 +15296,5 @@
                 IEM_MC_LOCAL(uint16_t, u16Target);
                 IEM_MC_FETCH_GREG_U16(u16Target, IEM_GET_MODRM_RM(pVCpu, bRm));
-                IEM_MC_SET_RIP_U16_AND_FINISH(u16Target);
+                IEM_MC_IND_JMP_U16_AND_FINISH(u16Target);
                 IEM_MC_END();
                 break;
@@ -15305,5 +15305,5 @@
                 IEM_MC_LOCAL(uint32_t, u32Target);
                 IEM_MC_FETCH_GREG_U32(u32Target, IEM_GET_MODRM_RM(pVCpu, bRm));
-                IEM_MC_SET_RIP_U32_AND_FINISH(u32Target);
+                IEM_MC_IND_JMP_U32_AND_FINISH(u32Target);
                 IEM_MC_END();
                 break;
@@ -15314,5 +15314,5 @@
                 IEM_MC_LOCAL(uint64_t, u64Target);
                 IEM_MC_FETCH_GREG_U64(u64Target, IEM_GET_MODRM_RM(pVCpu, bRm));
-                IEM_MC_SET_RIP_U64_AND_FINISH(u64Target);
+                IEM_MC_IND_JMP_U64_AND_FINISH(u64Target);
                 IEM_MC_END();
                 break;
@@ -15333,5 +15333,5 @@
                 IEMOP_HLP_DONE_DECODING_NO_LOCK_PREFIX();
                 IEM_MC_FETCH_MEM_U16(u16Target, pVCpu->iem.s.iEffSeg, GCPtrEffSrc);
-                IEM_MC_SET_RIP_U16_AND_FINISH(u16Target);
+                IEM_MC_IND_JMP_U16_AND_FINISH(u16Target);
                 IEM_MC_END();
                 break;
@@ -15344,5 +15344,5 @@
                 IEMOP_HLP_DONE_DECODING_NO_LOCK_PREFIX();
                 IEM_MC_FETCH_MEM_U32(u32Target, pVCpu->iem.s.iEffSeg, GCPtrEffSrc);
-                IEM_MC_SET_RIP_U32_AND_FINISH(u32Target);
+                IEM_MC_IND_JMP_U32_AND_FINISH(u32Target);
                 IEM_MC_END();
                 break;
@@ -15355,5 +15355,5 @@
                 IEMOP_HLP_DONE_DECODING_NO_LOCK_PREFIX();
                 IEM_MC_FETCH_MEM_U64(u64Target, pVCpu->iem.s.iEffSeg, GCPtrEffSrc);
-                IEM_MC_SET_RIP_U64_AND_FINISH(u64Target);
+                IEM_MC_IND_JMP_U64_AND_FINISH(u64Target);
                 IEM_MC_END();
                 break;
Index: trunk/src/VBox/VMM/VMMAll/target-x86/IEMAllN8veLiveness-x86.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/target-x86/IEMAllN8veLiveness-x86.h	(revision 108267)
+++ trunk/src/VBox/VMM/VMMAll/target-x86/IEMAllN8veLiveness-x86.h	(revision 108269)
@@ -348,16 +348,16 @@
 #define IEM_MC_REL_JMP_S32_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_i32, a_cbInstr, a_rcNormal)                        IEM_LIVENESS_PC64_JMP_WITH_FLAGS()
 #define IEM_MC_REL_JMP_S32_AND_FINISH_THREADED_PC64_INTRAPG_WITH_FLAGS(a_i32, a_cbInstr, a_rcNormal)                IEM_LIVENESS_PC64_INTRAPG_JMP_WITH_FLAGS()
-#define IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC16(a_u16NewIP)                                                     IEM_LIVENESS_PC16_JMP_NO_FLAGS()
-#define IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC32(a_u16NewIP)                                                     IEM_LIVENESS_PC32_JMP_NO_FLAGS()
-#define IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC64(a_u16NewIP)                                                     IEM_LIVENESS_PC64_JMP_NO_FLAGS()
-#define IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC16_WITH_FLAGS(a_u16NewIP)                                          IEM_LIVENESS_PC16_JMP_WITH_FLAGS()
-#define IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC32_WITH_FLAGS(a_u16NewIP)                                          IEM_LIVENESS_PC32_JMP_WITH_FLAGS()
-#define IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_u16NewIP)                                          IEM_LIVENESS_PC64_JMP_WITH_FLAGS()
-#define IEM_MC_SET_RIP_U32_AND_FINISH_THREADED_PC32(a_u32NewEIP)                                                    IEM_LIVENESS_PC32_JMP_NO_FLAGS()
-#define IEM_MC_SET_RIP_U32_AND_FINISH_THREADED_PC64(a_u32NewEIP)                                                    IEM_LIVENESS_PC64_JMP_NO_FLAGS()
-#define IEM_MC_SET_RIP_U32_AND_FINISH_THREADED_PC32_WITH_FLAGS(a_u32NewEIP)                                         IEM_LIVENESS_PC32_JMP_WITH_FLAGS()
-#define IEM_MC_SET_RIP_U32_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_u32NewEIP)                                         IEM_LIVENESS_PC64_JMP_WITH_FLAGS()
-#define IEM_MC_SET_RIP_U64_AND_FINISH_THREADED_PC64(a_u32NewEIP)                                                    IEM_LIVENESS_PC64_JMP_NO_FLAGS()
-#define IEM_MC_SET_RIP_U64_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_u32NewEIP)                                         IEM_LIVENESS_PC64_JMP_WITH_FLAGS()
+#define IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC16(a_u16NewIP)                                                     IEM_LIVENESS_PC16_JMP_NO_FLAGS()
+#define IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC32(a_u16NewIP)                                                     IEM_LIVENESS_PC32_JMP_NO_FLAGS()
+#define IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC64(a_u16NewIP)                                                     IEM_LIVENESS_PC64_JMP_NO_FLAGS()
+#define IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC16_WITH_FLAGS(a_u16NewIP)                                          IEM_LIVENESS_PC16_JMP_WITH_FLAGS()
+#define IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC32_WITH_FLAGS(a_u16NewIP)                                          IEM_LIVENESS_PC32_JMP_WITH_FLAGS()
+#define IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_u16NewIP)                                          IEM_LIVENESS_PC64_JMP_WITH_FLAGS()
+#define IEM_MC_IND_JMP_U32_AND_FINISH_THREADED_PC32(a_u32NewEIP)                                                    IEM_LIVENESS_PC32_JMP_NO_FLAGS()
+#define IEM_MC_IND_JMP_U32_AND_FINISH_THREADED_PC64(a_u32NewEIP)                                                    IEM_LIVENESS_PC64_JMP_NO_FLAGS()
+#define IEM_MC_IND_JMP_U32_AND_FINISH_THREADED_PC32_WITH_FLAGS(a_u32NewEIP)                                         IEM_LIVENESS_PC32_JMP_WITH_FLAGS()
+#define IEM_MC_IND_JMP_U32_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_u32NewEIP)                                         IEM_LIVENESS_PC64_JMP_WITH_FLAGS()
+#define IEM_MC_IND_JMP_U64_AND_FINISH_THREADED_PC64(a_u32NewEIP)                                                    IEM_LIVENESS_PC64_JMP_NO_FLAGS()
+#define IEM_MC_IND_JMP_U64_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_u32NewEIP)                                         IEM_LIVENESS_PC64_JMP_WITH_FLAGS()
 
 #define IEM_MC_REL_CALL_S16_AND_FINISH_THREADED_PC16(a_i16, a_cbInstr)                      do { IEM_LIVENESS_PC16_JMP_NO_FLAGS();   IEM_LIVENESS_STACK(); } while (0)
Index: trunk/src/VBox/VMM/VMMAll/target-x86/IEMAllN8veRecompFuncs-x86.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/target-x86/IEMAllN8veRecompFuncs-x86.h	(revision 108267)
+++ trunk/src/VBox/VMM/VMMAll/target-x86/IEMAllN8veRecompFuncs-x86.h	(revision 108269)
@@ -1409,74 +1409,74 @@
 
 /*********************************************************************************************************************************
-*   Emitters for changing PC/RIP/EIP/IP with a indirect jump (IEM_MC_SET_RIP_UXX_AND_FINISH).                                    *
+*   Emitters for changing PC/RIP/EIP/IP with a indirect jump (IEM_MC_IND_JMP_UXX_AND_FINISH).                                    *
 *********************************************************************************************************************************/
 
-/** Variant of IEM_MC_SET_RIP_U16_AND_FINISH for pre-386 targets. */
-#define IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC16(a_u16NewIP) \
+/** Variant of IEM_MC_IND_JMP_U16_AND_FINISH for pre-386 targets. */
+#define IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC16(a_u16NewIP) \
     off = iemNativeEmitRipJumpNoFlags(pReNative, off, (a_u16NewIP), false /*f64Bit*/, pCallEntry->idxInstr, sizeof(uint16_t))
 
-/** Variant of IEM_MC_SET_RIP_U16_AND_FINISH for 386+ targets. */
-#define IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC32(a_u16NewIP) \
+/** Variant of IEM_MC_IND_JMP_U16_AND_FINISH for 386+ targets. */
+#define IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC32(a_u16NewIP) \
     off = iemNativeEmitRipJumpNoFlags(pReNative, off, (a_u16NewIP), false /*f64Bit*/, pCallEntry->idxInstr, sizeof(uint16_t))
 
-/** Variant of IEM_MC_SET_RIP_U16_AND_FINISH for use in 64-bit code. */
-#define IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC64(a_u16NewIP) \
+/** Variant of IEM_MC_IND_JMP_U16_AND_FINISH for use in 64-bit code. */
+#define IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC64(a_u16NewIP) \
     off = iemNativeEmitRipJumpNoFlags(pReNative, off, (a_u16NewIP),  true /*f64Bit*/, pCallEntry->idxInstr, sizeof(uint16_t))
 
-/** Variant of IEM_MC_SET_RIP_U16_AND_FINISH for pre-386 targets that checks and
+/** Variant of IEM_MC_IND_JMP_U16_AND_FINISH for pre-386 targets that checks and
  *  clears flags. */
-#define IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC16_WITH_FLAGS(a_u16NewIP) \
-    IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC16(a_u16NewIP); \
+#define IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC16_WITH_FLAGS(a_u16NewIP) \
+    IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC16(a_u16NewIP); \
     off = iemNativeEmitFinishInstructionFlagsCheck(pReNative, off)
 
-/** Variant of IEM_MC_SET_RIP_U16_AND_FINISH for 386+ targets that checks and
+/** Variant of IEM_MC_IND_JMP_U16_AND_FINISH for 386+ targets that checks and
  *  clears flags. */
-#define IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC32_WITH_FLAGS(a_u16NewIP) \
-    IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC32(a_u16NewIP); \
+#define IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC32_WITH_FLAGS(a_u16NewIP) \
+    IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC32(a_u16NewIP); \
     off = iemNativeEmitFinishInstructionFlagsCheck(pReNative, off)
 
-/** Variant of IEM_MC_SET_RIP_U16_AND_FINISH for use in 64-bit code that checks and
+/** Variant of IEM_MC_IND_JMP_U16_AND_FINISH for use in 64-bit code that checks and
  *  clears flags. */
-#define IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_u16NewIP) \
-    IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC64(a_u16NewIP); \
+#define IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_u16NewIP) \
+    IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC64(a_u16NewIP); \
     off = iemNativeEmitFinishInstructionFlagsCheck(pReNative, off)
 
-#undef IEM_MC_SET_RIP_U16_AND_FINISH
-
-
-/** Variant of IEM_MC_SET_RIP_U32_AND_FINISH for 386+ targets. */
-#define IEM_MC_SET_RIP_U32_AND_FINISH_THREADED_PC32(a_u32NewEIP) \
+#undef IEM_MC_IND_JMP_U16_AND_FINISH
+
+
+/** Variant of IEM_MC_IND_JMP_U32_AND_FINISH for 386+ targets. */
+#define IEM_MC_IND_JMP_U32_AND_FINISH_THREADED_PC32(a_u32NewEIP) \
     off = iemNativeEmitRipJumpNoFlags(pReNative, off, (a_u32NewEIP), false /*f64Bit*/, pCallEntry->idxInstr, sizeof(uint32_t))
 
-/** Variant of IEM_MC_SET_RIP_U32_AND_FINISH for use in 64-bit code. */
-#define IEM_MC_SET_RIP_U32_AND_FINISH_THREADED_PC64(a_u32NewEIP) \
+/** Variant of IEM_MC_IND_JMP_U32_AND_FINISH for use in 64-bit code. */
+#define IEM_MC_IND_JMP_U32_AND_FINISH_THREADED_PC64(a_u32NewEIP) \
     off = iemNativeEmitRipJumpNoFlags(pReNative, off, (a_u32NewEIP),  true /*f64Bit*/, pCallEntry->idxInstr, sizeof(uint32_t))
 
-/** Variant of IEM_MC_SET_RIP_U32_AND_FINISH for 386+ targets that checks and
+/** Variant of IEM_MC_IND_JMP_U32_AND_FINISH for 386+ targets that checks and
  *  clears flags. */
-#define IEM_MC_SET_RIP_U32_AND_FINISH_THREADED_PC32_WITH_FLAGS(a_u32NewEIP) \
-    IEM_MC_SET_RIP_U32_AND_FINISH_THREADED_PC32(a_u32NewEIP); \
+#define IEM_MC_IND_JMP_U32_AND_FINISH_THREADED_PC32_WITH_FLAGS(a_u32NewEIP) \
+    IEM_MC_IND_JMP_U32_AND_FINISH_THREADED_PC32(a_u32NewEIP); \
     off = iemNativeEmitFinishInstructionFlagsCheck(pReNative, off)
 
-/** Variant of IEM_MC_SET_RIP_U32_AND_FINISH for use in 64-bit code that checks
+/** Variant of IEM_MC_IND_JMP_U32_AND_FINISH for use in 64-bit code that checks
  *  and clears flags. */
-#define IEM_MC_SET_RIP_U32_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_u32NewEIP) \
-    IEM_MC_SET_RIP_U32_AND_FINISH_THREADED_PC64(a_u32NewEIP); \
+#define IEM_MC_IND_JMP_U32_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_u32NewEIP) \
+    IEM_MC_IND_JMP_U32_AND_FINISH_THREADED_PC64(a_u32NewEIP); \
     off = iemNativeEmitFinishInstructionFlagsCheck(pReNative, off)
 
-#undef IEM_MC_SET_RIP_U32_AND_FINISH
-
-
-/** Variant of IEM_MC_SET_RIP_U64_AND_FINISH for use in 64-bit code. */
-#define IEM_MC_SET_RIP_U64_AND_FINISH_THREADED_PC64(a_u64NewEIP) \
+#undef IEM_MC_IND_JMP_U32_AND_FINISH
+
+
+/** Variant of IEM_MC_IND_JMP_U64_AND_FINISH for use in 64-bit code. */
+#define IEM_MC_IND_JMP_U64_AND_FINISH_THREADED_PC64(a_u64NewEIP) \
     off = iemNativeEmitRipJumpNoFlags(pReNative, off, (a_u64NewEIP),  true /*f64Bit*/, pCallEntry->idxInstr, sizeof(uint64_t))
 
-/** Variant of IEM_MC_SET_RIP_U64_AND_FINISH for use in 64-bit code that checks
+/** Variant of IEM_MC_IND_JMP_U64_AND_FINISH for use in 64-bit code that checks
  *  and clears flags. */
-#define IEM_MC_SET_RIP_U64_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_u64NewEIP) \
-    IEM_MC_SET_RIP_U64_AND_FINISH_THREADED_PC64(a_u64NewEIP); \
+#define IEM_MC_IND_JMP_U64_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_u64NewEIP) \
+    IEM_MC_IND_JMP_U64_AND_FINISH_THREADED_PC64(a_u64NewEIP); \
     off = iemNativeEmitFinishInstructionFlagsCheck(pReNative, off)
 
-#undef IEM_MC_SET_RIP_U64_AND_FINISH
+#undef IEM_MC_IND_JMP_U64_AND_FINISH
 
 
Index: trunk/src/VBox/VMM/VMMAll/target-x86/IEMAllThrdFuncs-x86.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/target-x86/IEMAllThrdFuncs-x86.cpp	(revision 108267)
+++ trunk/src/VBox/VMM/VMMAll/target-x86/IEMAllThrdFuncs-x86.cpp	(revision 108269)
@@ -301,65 +301,65 @@
 
 
-/** Variant of IEM_MC_SET_RIP_U16_AND_FINISH for pre-386 targets. */
-#define IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC16(a_u16NewIP) \
+/** Variant of IEM_MC_IND_JMP_U16_AND_FINISH for pre-386 targets. */
+#define IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC16(a_u16NewIP) \
     return iemRegRipJumpU16AndFinishNoFlags((pVCpu), (a_u16NewIP))
 
-/** Variant of IEM_MC_SET_RIP_U16_AND_FINISH for 386+ targets. */
-#define IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC32(a_u16NewIP) \
+/** Variant of IEM_MC_IND_JMP_U16_AND_FINISH for 386+ targets. */
+#define IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC32(a_u16NewIP) \
     return iemRegRipJumpU16AndFinishNoFlags((pVCpu), (a_u16NewIP))
 
-/** Variant of IEM_MC_SET_RIP_U16_AND_FINISH for use in 64-bit code. */
-#define IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC64(a_u16NewIP) \
+/** Variant of IEM_MC_IND_JMP_U16_AND_FINISH for use in 64-bit code. */
+#define IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC64(a_u16NewIP) \
     return iemRegRipJumpU16AndFinishNoFlags((pVCpu), (a_u16NewIP))
 
-/** Variant of IEM_MC_SET_RIP_U16_AND_FINISH for pre-386 targets that checks and
+/** Variant of IEM_MC_IND_JMP_U16_AND_FINISH for pre-386 targets that checks and
  *  clears flags. */
-#define IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC16_WITH_FLAGS(a_u16NewIP) \
+#define IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC16_WITH_FLAGS(a_u16NewIP) \
     return iemRegRipJumpU16AndFinishClearingRF((pVCpu), (a_u16NewIP), 0 /* cbInstr - not used */)
 
-/** Variant of IEM_MC_SET_RIP_U16_AND_FINISH for 386+ targets that checks and
+/** Variant of IEM_MC_IND_JMP_U16_AND_FINISH for 386+ targets that checks and
  *  clears flags. */
-#define IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC32_WITH_FLAGS(a_u16NewIP) \
+#define IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC32_WITH_FLAGS(a_u16NewIP) \
     return iemRegRipJumpU16AndFinishClearingRF((pVCpu), (a_u16NewIP), 0 /* cbInstr - not used */)
 
-/** Variant of IEM_MC_SET_RIP_U16_AND_FINISH for use in 64-bit code that checks and
+/** Variant of IEM_MC_IND_JMP_U16_AND_FINISH for use in 64-bit code that checks and
  *  clears flags. */
-#define IEM_MC_SET_RIP_U16_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_u16NewIP) \
+#define IEM_MC_IND_JMP_U16_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_u16NewIP) \
     return iemRegRipJumpU16AndFinishClearingRF((pVCpu), (a_u16NewIP), 0 /* cbInstr - not used */)
 
-#undef IEM_MC_SET_RIP_U16_AND_FINISH
-
-
-/** Variant of IEM_MC_SET_RIP_U32_AND_FINISH for 386+ targets. */
-#define IEM_MC_SET_RIP_U32_AND_FINISH_THREADED_PC32(a_u32NewEIP) \
+#undef IEM_MC_IND_JMP_U16_AND_FINISH
+
+
+/** Variant of IEM_MC_IND_JMP_U32_AND_FINISH for 386+ targets. */
+#define IEM_MC_IND_JMP_U32_AND_FINISH_THREADED_PC32(a_u32NewEIP) \
     return iemRegRipJumpU32AndFinishNoFlags((pVCpu), (a_u32NewEIP))
 
-/** Variant of IEM_MC_SET_RIP_U32_AND_FINISH for use in 64-bit code. */
-#define IEM_MC_SET_RIP_U32_AND_FINISH_THREADED_PC64(a_u32NewEIP) \
+/** Variant of IEM_MC_IND_JMP_U32_AND_FINISH for use in 64-bit code. */
+#define IEM_MC_IND_JMP_U32_AND_FINISH_THREADED_PC64(a_u32NewEIP) \
     return iemRegRipJumpU32AndFinishNoFlags((pVCpu), (a_u32NewEIP))
 
-/** Variant of IEM_MC_SET_RIP_U32_AND_FINISH for 386+ targets that checks and
+/** Variant of IEM_MC_IND_JMP_U32_AND_FINISH for 386+ targets that checks and
  *  clears flags. */
-#define IEM_MC_SET_RIP_U32_AND_FINISH_THREADED_PC32_WITH_FLAGS(a_u32NewEIP) \
+#define IEM_MC_IND_JMP_U32_AND_FINISH_THREADED_PC32_WITH_FLAGS(a_u32NewEIP) \
     return iemRegRipJumpU32AndFinishClearingRF((pVCpu), (a_u32NewEIP), 0 /* cbInstr - not used */)
 
-/** Variant of IEM_MC_SET_RIP_U32_AND_FINISH for use in 64-bit code that checks
+/** Variant of IEM_MC_IND_JMP_U32_AND_FINISH for use in 64-bit code that checks
  *  and clears flags. */
-#define IEM_MC_SET_RIP_U32_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_u32NewEIP) \
+#define IEM_MC_IND_JMP_U32_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_u32NewEIP) \
     return iemRegRipJumpU32AndFinishClearingRF((pVCpu), (a_u32NewEIP), 0 /* cbInstr - not used */)
 
-#undef IEM_MC_SET_RIP_U32_AND_FINISH
-
-
-/** Variant of IEM_MC_SET_RIP_U64_AND_FINISH for use in 64-bit code. */
-#define IEM_MC_SET_RIP_U64_AND_FINISH_THREADED_PC64(a_u32NewEIP) \
+#undef IEM_MC_IND_JMP_U32_AND_FINISH
+
+
+/** Variant of IEM_MC_IND_JMP_U64_AND_FINISH for use in 64-bit code. */
+#define IEM_MC_IND_JMP_U64_AND_FINISH_THREADED_PC64(a_u32NewEIP) \
     return iemRegRipJumpU64AndFinishNoFlags((pVCpu), (a_u32NewEIP))
 
-/** Variant of IEM_MC_SET_RIP_U64_AND_FINISH for use in 64-bit code that checks
+/** Variant of IEM_MC_IND_JMP_U64_AND_FINISH for use in 64-bit code that checks
  *  and clears flags. */
-#define IEM_MC_SET_RIP_U64_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_u32NewEIP) \
+#define IEM_MC_IND_JMP_U64_AND_FINISH_THREADED_PC64_WITH_FLAGS(a_u32NewEIP) \
     return iemRegRipJumpU64AndFinishClearingRF((pVCpu), (a_u32NewEIP), 0 /* cbInstr - not used */)
 
-#undef IEM_MC_SET_RIP_U64_AND_FINISH
+#undef IEM_MC_IND_JMP_U64_AND_FINISH
 
 