Index: /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 108355)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 108356)
@@ -291,4 +291,5 @@
         case UIToolType_Home:
         case UIToolType_Machines:
+        case UIToolType_Managers:
         case UIToolType_Extensions:
         case UIToolType_Media:
Index: /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 108355)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 108356)
@@ -943,5 +943,6 @@
     UIToolClass_Aux,
     UIToolClass_Global,
-    UIToolClass_Machine
+    UIToolClass_Machine,
+    UIToolClass_Management
 };
 
@@ -956,4 +957,5 @@
     UIToolType_Home,
     UIToolType_Machines,
+    UIToolType_Managers,
     UIToolType_Extensions,
     UIToolType_Media,
Index: /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 108355)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 108356)
@@ -2873,5 +2873,7 @@
 }
 
-void UIExtraDataManager::toolsPaneLastItemsChosen(UIToolType &enmTypeGlobal, UIToolType &enmTypeMachine)
+void UIExtraDataManager::toolsPaneLastItemsChosen(UIToolType &enmTypeGlobal,
+                                                  UIToolType &enmTypeMachine,
+                                                  UIToolType &enmTypeManagement)
 {
     /* Parse loaded data: */
@@ -2891,10 +2893,18 @@
     if (!UIToolStuff::isTypeOfClass(enmTypeMachine, UIToolClass_Machine))
         enmTypeMachine = UIToolType_Details;
-}
-
-void UIExtraDataManager::setToolsPaneLastItemsChosen(UIToolType enmTypeGlobal, UIToolType enmTypeMachine)
+    enmTypeManagement = result.value(2);
+    if (!UIToolStuff::isTypeOfClass(enmTypeManagement, UIToolClass_Management))
+        enmTypeManagement = UIToolType_Extensions;
+}
+
+void UIExtraDataManager::setToolsPaneLastItemsChosen(UIToolType enmTypeGlobal,
+                                                     UIToolType enmTypeMachine,
+                                                     UIToolType enmTypeManagement)
 {
     /* Serialize passed values: */
-    const QList<UIToolType> currentTypes = QList<UIToolType>() << enmTypeGlobal << enmTypeMachine;
+    const QList<UIToolType> currentTypes = QList<UIToolType>()
+                                         << enmTypeGlobal
+                                         << enmTypeMachine
+                                         << enmTypeManagement;
     QStringList data;
     foreach (const UIToolType &enmType, currentTypes)
Index: /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 108355)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 108356)
@@ -400,7 +400,11 @@
 
         /** Returns last selected tool set of VirtualBox Manager. */
-        void toolsPaneLastItemsChosen(UIToolType &enmTypeGlobal, UIToolType &enmTypeMachine);
+        void toolsPaneLastItemsChosen(UIToolType &enmTypeGlobal,
+                                      UIToolType &enmTypeMachine,
+                                      UIToolType &enmTypeManagement);
         /** Defines last selected tool @a set of VirtualBox Manager. */
-        void setToolsPaneLastItemsChosen(UIToolType enmTypeGlobal, UIToolType enmTypeMachine);
+        void setToolsPaneLastItemsChosen(UIToolType enmTypeGlobal,
+                                         UIToolType enmTypeMachine,
+                                         UIToolType enmTypeManagement);
         /** Returns the list of detached tools of VirtualBox Manager. */
         QList<UIToolType> detachedTools();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsManagerWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsManagerWidget.cpp	(revision 108355)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsManagerWidget.cpp	(revision 108356)
@@ -117,5 +117,5 @@
     toolPane()->openTool(enmType);
 
-    /* Special handling for Machines Global tool,
+    /* Special handling for Machines global tool,
      * notify Machine tool-pane it's active: */
     if (enmType == UIToolType_Machines)
@@ -272,6 +272,7 @@
     if (enmClass == UIToolClass_Global)
     {
-        /* Mark Machine tools [un]suitable depending on Global tool selected: */
+        /* Mark Machine & Management tools [un]suitable depending on Global tool selected: */
         toolMenu()->setUnsuitableToolClass(UIToolClass_Machine, enmType != UIToolType_Machines);
+        toolMenu()->setUnsuitableToolClass(UIToolClass_Management, enmType != UIToolType_Managers);
 
         /* Switch tool-pane accordingly: */
@@ -281,4 +282,7 @@
     else if (enmClass == UIToolClass_Machine)
         machineToolManager()->switchToolTo(enmType);
+    /* For Management tool class => switch tool-pane accordingly: */
+    else if (enmClass == UIToolClass_Management)
+        switchToolTo(enmType);
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsItem.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsItem.cpp	(revision 108355)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsItem.cpp	(revision 108356)
@@ -575,6 +575,8 @@
             fnt.setWeight(QFont::Bold);
 
-            /* Make Machine tool font smaller for widget mode: */
-            if (!model()->isPopup() && itemClass() == UIToolClass_Machine)
+            /* Make Machine & Management tool font smaller for widget mode: */
+            if (   !model()->isPopup()
+                && (   itemClass() == UIToolClass_Machine
+                    || itemClass() == UIToolClass_Management))
                 fnt.setPointSize(fnt.pointSize() - 1);
 
@@ -591,8 +593,10 @@
 void UIToolsItem::updatePixmap()
 {
-    /* Smaller Machine tool icons in widget mode: */
-    const int iIconMetric = model()->isPopup() || itemClass() != UIToolClass_Machine
-                          ? QApplication::style()->pixelMetric(QStyle::PM_SmallIconSize) * 1.5
-                          : QApplication::style()->pixelMetric(QStyle::PM_SmallIconSize);
+    /* Smaller Machine & Management tool icons in widget mode: */
+    const int iIconMetric =    !model()->isPopup()
+                            && (   itemClass() == UIToolClass_Machine
+                                || itemClass() == UIToolClass_Management)
+                          ? QApplication::style()->pixelMetric(QStyle::PM_SmallIconSize)
+                          : QApplication::style()->pixelMetric(QStyle::PM_SmallIconSize) * 1.5;
 
     /* Prepare new pixmap size: */
@@ -792,4 +796,5 @@
                 }
                 case UIToolClass_Machine:
+                case UIToolClass_Management:
                 {
                     /* A bit of indentation for Machine tools in widget mode: */
@@ -839,6 +844,6 @@
 #endif /* !VBOX_WS_MAC */
 
-            /* A bit of indentation for Machine tools in widget mode: */
-            const int iIndent = itemClass() == UIToolClass_Machine
+            /* A bit of indentation for Machine & Management tools in widget mode: */
+            const int iIndent = itemClass() == UIToolClass_Machine || itemClass() == UIToolClass_Management
                               ? QApplication::style()->pixelMetric(QStyle::PM_SmallIconSize) * .5 : 0;
 
@@ -966,6 +971,8 @@
 #endif
 
-        /* A bit of indentation for Machine tools in widget mode: */
-        if (!model()->isPopup() && itemClass() == UIToolClass_Machine)
+        /* A bit of indentation for Machine & Management tools in widget mode: */
+        if (   !model()->isPopup()
+            && (   itemClass() == UIToolClass_Machine
+                || itemClass() == UIToolClass_Management))
             iPixmapX += QApplication::style()->pixelMetric(QStyle::PM_SmallIconSize) * .5;
 
@@ -992,6 +999,8 @@
 #endif
 
-        /* A bit of indentation for Machine tools in widget mode: */
-        if (!model()->isPopup() && itemClass() == UIToolClass_Machine)
+        /* A bit of indentation for Machine & Management tools in widget mode: */
+        if (   !model()->isPopup()
+            && (   itemClass() == UIToolClass_Machine
+                || itemClass() == UIToolClass_Management))
             iNameX += QApplication::style()->pixelMetric(QStyle::PM_SmallIconSize) * .5;
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp	(revision 108355)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp	(revision 108356)
@@ -207,5 +207,6 @@
         /* Is there something changed? */
         if (   !m_mapCurrentItems.value(UIToolClass_Global)
-            && !m_mapCurrentItems.value(UIToolClass_Machine))
+            && !m_mapCurrentItems.value(UIToolClass_Machine)
+            && !m_mapCurrentItems.value(UIToolClass_Management))
             return;
 
@@ -213,4 +214,5 @@
         m_mapCurrentItems[UIToolClass_Global] = 0;
         m_mapCurrentItems[UIToolClass_Machine] = 0;
+        m_mapCurrentItems[UIToolClass_Management] = 0;
 
         /* Notify about selection change: */
@@ -379,4 +381,5 @@
                         case UIToolClass_Global:
                         case UIToolClass_Machine:
+                        case UIToolClass_Management:
                         {
                             /* Make clicked item the current one: */
@@ -418,7 +421,10 @@
         switch (pItem->itemType())
         {
+            // Aux
             case UIToolType_Toggle:      pItem->setName(tr("Show text")); break;
+            // Global
             case UIToolType_Home:        pItem->setName(tr("Home")); break;
             case UIToolType_Machines:    pItem->setName(tr("Machines")); break;
+            case UIToolType_Managers:    pItem->setName(tr("Management")); break;
             case UIToolType_Extensions:  pItem->setName(tr("Extensions")); break;
             case UIToolType_Media:       pItem->setName(tr("Media")); break;
@@ -426,4 +432,5 @@
             case UIToolType_Cloud:       pItem->setName(tr("Cloud")); break;
             case UIToolType_Activities:  pItem->setName(tr("Activities")); break;
+            // Machine
             case UIToolType_Details:     pItem->setName(tr("Details")); break;
             case UIToolType_Snapshots:   pItem->setName(tr("Snapshots")); break;
@@ -463,5 +470,9 @@
                                                                 ":/welcome_screen_24px.png"),
                                    UIToolClass_Global, UIToolType_Home);
-
+    }
+
+    if (   m_enmClass == UIToolClass_Global
+        || m_enmClass == UIToolClass_Invalid)
+    {
         /* Machines: */
         m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/machine_details_manager_24px.png",
@@ -499,4 +510,13 @@
     }
 
+    if (   m_enmClass == UIToolClass_Management
+        || m_enmClass == UIToolClass_Invalid)
+    {
+        /* Management: */
+        m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/extension_pack_manager_24px.png",
+                                                                ":/extension_pack_manager_disabled_24px.png"),
+                                   UIToolClass_Global, UIToolType_Managers);
+    }
+
     if (   m_enmClass == UIToolClass_Global
         || m_enmClass == UIToolClass_Invalid)
@@ -526,5 +546,9 @@
                                                                 ":/resources_monitor_disabled_24px.png"),
                                    UIToolClass_Global, UIToolType_Activities);
-
+    }
+
+    if (   m_enmClass == UIToolClass_Global
+        || m_enmClass == UIToolClass_Invalid)
+    {
         /* Toggle: */
         m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/tools_menu_24px.png",
@@ -548,8 +572,8 @@
 {
     /* Load last tool types: */
-    UIToolType enmTypeGlobal, enmTypeMachine;
-    gEDataManager->toolsPaneLastItemsChosen(enmTypeGlobal, enmTypeMachine);
-    LogRel2(("GUI: UIToolsModel: Restoring tool items as: Global=%d, Machine=%d\n",
-             (int)enmTypeGlobal, (int)enmTypeMachine));
+    UIToolType enmTypeGlobal, enmTypeMachine, enmTypeManagment;
+    gEDataManager->toolsPaneLastItemsChosen(enmTypeGlobal, enmTypeMachine, enmTypeManagment);
+    LogRel2(("GUI: UIToolsModel: Restoring tool items as: Global=%d, Machine=%d, Management=%d\n",
+             (int)enmTypeGlobal, (int)enmTypeMachine, (int)enmTypeManagment));
 
     /* Assign values depending on model class: */
@@ -570,4 +594,12 @@
         setCurrentItem(pItem);
     }
+    if (   m_enmClass == UIToolClass_Management
+        || m_enmClass == UIToolClass_Invalid)
+    {
+        UIToolsItem *pItem = item(enmTypeManagment);
+        if (!pItem)
+            pItem = item(UIToolType_Extensions);
+        setCurrentItem(pItem);
+    }
 }
 
@@ -575,6 +607,6 @@
 {
     /* Load last tool types: */
-    UIToolType enmTypeGlobal, enmTypeMachine;
-    gEDataManager->toolsPaneLastItemsChosen(enmTypeGlobal, enmTypeMachine);
+    UIToolType enmTypeGlobal, enmTypeMachine, enmTypeManagment;
+    gEDataManager->toolsPaneLastItemsChosen(enmTypeGlobal, enmTypeMachine, enmTypeManagment);
 
     /* Update values depending on model class: */
@@ -591,9 +623,15 @@
             enmTypeMachine = pItem->itemType();
     }
+    if (   m_enmClass == UIToolClass_Management
+        || m_enmClass == UIToolClass_Invalid)
+    {
+        if (UIToolsItem *pItem = currentItem(UIToolClass_Management))
+            enmTypeMachine = pItem->itemType();
+    }
 
     /* Save selected items data: */
-    LogRel2(("GUI: UIToolsModel: Saving tool items as: Global=%d, Machine=%d\n",
-             (int)enmTypeGlobal, (int)enmTypeMachine));
-    gEDataManager->setToolsPaneLastItemsChosen(enmTypeGlobal, enmTypeMachine);
+    LogRel2(("GUI: UIToolsModel: Saving tool items as: Global=%d, Machine=%d, Management=%d\n",
+             (int)enmTypeGlobal, (int)enmTypeMachine, (int)enmTypeManagment));
+    gEDataManager->setToolsPaneLastItemsChosen(enmTypeGlobal, enmTypeMachine, enmTypeManagment);
 }
 